package com.madeu.crm.contentsBbs.ctrl;

import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.ModelAndView;

import com.madeu.constants.Constants;
import com.madeu.crm.contentsBbs.service.ContentsBbsService;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.web.webloghistory.WebLogHistoryService;
import com.madeu.util.HttpUtil;
import com.madeu.util.RequestLogUtil;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Controller
public class ContentsBbsController extends ManagerDraftAction {

    @Autowired
    private ContentsBbsService contentsBbsService;

    @Autowired
    private WebLogHistoryService webLogHistoryService;

    /**
     * 홈페이지 시술예약(쁘띠) 리스트 화면으로 이동.
     *
     * @param request
     * @param response
     * @return
     */
    @PostMapping("/contentsBbs/moveContentsBbsList.do")
    public String  moveContentsBbsList(HttpSession session, HttpServletRequest request, HttpServletResponse response, Model model) {
        log.debug("WebTreatmentPetitController  selectListWebTreatmentPetitIntro START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return "/web/login/logout";
            }
            else {
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = contentsBbsService.selectListWebTreatmentPetitIntro(paramMap);

                model.addAttribute("selectUseYn", map.get("selectUseYn"));
                model.addAttribute("insertUseYn", map.get("insertUseYn"));
                model.addAttribute("updateUseYn", map.get("updateUseYn"));
                model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
                model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return "/web/login/logout";
        }
        log.debug("WebTreatmentPetitController  selectListWebTreatmentPetitIntro END");
        
        
        model.addAttribute("categoryDivCd", getMenuToCdTitle(paramMap.get("menuClass")).get("cd"));
        model.addAttribute("title", getMenuToCdTitle(paramMap.get("menuClass")).get("title"));
        
        return "/web/contentsBbs/ContentsBbsSelectList";
    }

    /**
     * 홈페이지 시술예약(쁘띠) 정보 리스트 조회
     *
     * @param request
     * @param response
     * @return
     */
    @PostMapping("/contentsBbs/getContentsBbsList.do")
    public ModelAndView getContentsBbsList(HttpSession session, HttpServletRequest request, HttpServletResponse response) {

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = contentsBbsService.getContentsBbsList(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("WebTreatmentPetitController selectListWebTreatmentPetit END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    /**
     * 홈페이지 시술예약(쁘띠) 정보 상세 조회
     *
     * @param request
     * @param response
     * @return
     */
    @PostMapping("/contentsBbs/getContentsBbs.do")
    public ModelAndView getContentsBbs(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
        log.debug("WebTreatmentPetitController selectWebTreatmentPetit START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = contentsBbsService.getContentsBbs(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("WebTreatmentPetitController selectWebTreatmentPetit END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }
    
    /**
     * 홈페이지 등록 화면으로 이동.
     *
     * @param request
     * @param response
     * @return
     */
    @PostMapping("/contentsBbs/moveRegContentsBbs.do")
    public String  moveRegContentsBbs(HttpSession session, HttpServletRequest request, HttpServletResponse response, Model model) {
        log.debug("ContentsBbsController moveRegContentsBbs START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return "/web/login/logout";
            }
            else {
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = contentsBbsService.insertWebTreatmentPetitIntro(paramMap);

                model.addAttribute("selectUseYn", map.get("selectUseYn"));
                model.addAttribute("insertUseYn", map.get("insertUseYn"));
                model.addAttribute("updateUseYn", map.get("updateUseYn"));
                model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
                model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
                model.addAttribute("categorylist", map.get("categorylist"));
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return "/web/login/logout";
        }
        log.debug("ContentsBbsController moveRegContentsBbs END");
        
        model.addAttribute("title", getMenuToCdTitle(paramMap.get("menuClass")).get("title"));
        
        return "/web/contentsBbs/ContentsBbsReg";
    }

    /**
     * 홈페이지 시술예약(쁘띠) 정보 등록
     *
     * @param request
     * @param response
     * @return
     */
    @PostMapping(value="/contentsBbs/putContentsBbs.do")
    public ModelAndView putContentsBbs(HttpSession session,HttpServletRequest request, HttpServletResponse response,@RequestParam(value = "file", required = false) MultipartFile file,@RequestParam(value = "content_file", required = false) MultipartFile content_file) {
        log.debug("ContentsBbsController putContentsBbs START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
                map = contentsBbsService.putContentsBbs(paramMap,file,content_file);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            try {
                HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
                HashMap<String, Object> insertMap = new HashMap<String, Object>();

                insertMap.put("url", "/webtreatmentpetit/insertWebTreatmentPetit.do");
                insertMap.put("func", "insertWebTreatmentPetit");
                insertMap.put("funcName", "홈페이지 시술예약(쁘띠) 등록");
                insertMap.put("service", "webTreatmentPetitService");
                insertMap.put("serviceName", "홈페이지 시술예약(쁘띠) 등록");
                insertMap.put("requestValue", String.valueOf(paramMap));
                insertMap.put("responseValue", String.valueOf(map));
                insertMap.put("tId", map.get("tId"));
                if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
                    insertMap.put("resultCode", "SUCCESS");
                }
                else{
                    insertMap.put("resultCode", "ERROR");
                }
                insertMap.put("resultMsg", String.valueOf(errorMsg));
                insertMap.put("muMemberId", paramMap.get("loginMemberId"));

                webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        log.debug("ContentsBbsController putContentsBbs END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    /**
     * 홈페이지 시술예약(쁘띠) 수정 화면으로 이동.
     *
     * @param request
     * @param response
     * @return
     */
    @PostMapping(value="/contentsBbs/moveContentsBbs.do")
    public String  moveContentsBbs(HttpSession session, HttpServletRequest request, HttpServletResponse response, Model model) {
        log.debug("ContentsBbsController  moveContentsBbs START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return "/web/login/logout";
            }
            else {
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = contentsBbsService.moveContentsBbs(paramMap);

                model.addAttribute("selectUseYn", map.get("selectUseYn"));
                model.addAttribute("insertUseYn", map.get("insertUseYn"));
                model.addAttribute("updateUseYn", map.get("updateUseYn"));
                model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
                model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
                model.addAttribute("categoryDivCd", paramMap.get("categoryDivCd"));
                model.addAttribute("category", map.get("category"));
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return "/web/login/logout";
        }
        
        model.addAttribute("title", getMenuToCdTitle(paramMap.get("menuClass")).get("title"));
        
        log.debug("ContentsBbsController  moveContentsBbs END");
        return "/web/contentsBbs/ContentsBbsUpd";
    }

    /**
     * 홈페이지 시술예약(쁘띠) 정보 수정
     *
     * @param request
     * @param response
     * @return
     */
    @PostMapping(value="/contentsBbs/modContentsBbs.do")
    public ModelAndView modContentsBbs(HttpSession session,HttpServletRequest request, HttpServletResponse response, @RequestParam(value = "file", required = false) MultipartFile file, @RequestParam(value = "content_file", required = false) MultipartFile content_file) {
        log.debug("WebTreatmentPetitController updateWebTreatmentPetit START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
                map = contentsBbsService.modContentsBbs(paramMap, file, content_file );
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            try {
                HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
                HashMap<String, Object> insertMap = new HashMap<String, Object>();

                insertMap.put("url", "/webtreatmentpetit/updateWebTreatmentPetit.do");
                insertMap.put("func", "updateWebTreatmentPetit");
                insertMap.put("funcName", "홈페이지 시술예약(쁘띠) 수정");
                insertMap.put("service", "webTreatmentPetitService");
                insertMap.put("serviceName", "홈페이지 시술예약(쁘띠) 수정");
                insertMap.put("requestValue", String.valueOf(paramMap));
                insertMap.put("responseValue", String.valueOf(map));
                insertMap.put("tId", map.get("tId"));
                if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
                    insertMap.put("resultCode", "SUCCESS");
                }
                else{
                    insertMap.put("resultCode", "ERROR");
                }
                insertMap.put("resultMsg", String.valueOf(errorMsg));
                insertMap.put("muMemberId", paramMap.get("loginMemberId"));

                webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        log.debug("WebTreatmentPetitController updateWebTreatmentPetit END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }


    /**
     * 홈페이지 시술예약(쁘띠) 정보 삭제
     *
     * @param request
     * @param response
     * @return
     */
    @PostMapping(value="/contentsBbs/delContentsBbs.do")
    public ModelAndView delContentsBbs(@RequestBody HashMap<String, Object> paramMap, HttpSession session, HttpServletRequest request, HttpServletResponse response) {
        log.debug("WebTreatmentPetitController deleteWebTreatmentPetit START");

        //HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();
        
        
        
        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
                map = contentsBbsService.delContentsBbs(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            try {
                HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
                HashMap<String, Object> insertMap = new HashMap<String, Object>();

                insertMap.put("url", "/webtreatmentpetit/deleteWebTreatmentPetit.do");
                insertMap.put("func", "deleteWebTreatmentPetit");
                insertMap.put("funcName", "홈페이지 시술예약(쁘띠) 삭제");
                insertMap.put("service", "webTreatmentPetitService");
                insertMap.put("serviceName", "홈페이지 시술예약(쁘띠) 삭제");
                insertMap.put("requestValue", String.valueOf(paramMap));
                insertMap.put("responseValue", String.valueOf(map));
                insertMap.put("tId", map.get("tId"));
                if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
                    insertMap.put("resultCode", "SUCCESS");
                }
                else{
                    insertMap.put("resultCode", "ERROR");
                }
                insertMap.put("resultMsg", String.valueOf(errorMsg));
                insertMap.put("muMemberId", paramMap.get("loginMemberId"));

                webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        log.debug("WebTreatmentPetitController deleteWebTreatmentPetit END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }
    
    /**
     * 시술 정보 리스트 조회 (option)
     * 시술등록 팝업
     * @param request
     * @param response
     * @return
     */
    //@RequestMapping(value = "/webtreatmentpetit/selectListTreatmentOption.do")
    public ModelAndView selectListTreatmentOption(HttpSession session, HttpServletRequest request, HttpServletResponse response) {
        log.debug("WebTreatmentPetitController selectListTreatmentOption START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try {
            if (!webCheckLogin(session)) {
                return null;
            } else {
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = contentsBbsService.selectListTreatmentOption(paramMap);
            }
        }
			catch (Exception e) {
            e.printStackTrace();
            return null;
        } finally {
            if (Constants.OK == map.get("msgCode")) {

            } else {
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if (null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc", "정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("WebTreatmentPetitController selectListTreatmentOption END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }
    
    private HashMap<String, String> getMenuToCdTitle(Object obj) {
    	HashMap<String, String> map = new HashMap<String, String>();
    	String cd = "";
        String title = "";
        if( "100101".equals(obj) ) {
        	cd = "01";
        	title = "시술예약(다이어트)";
        } else if( "100102".equals(obj) ) {
        	cd = "02";
        	title = "이벤트(다이어트)";
        } else if( "100201".equals(obj) ) {
        	cd = "03";
        	title = "시술예약(쁘띠)";
        } else if( "100202".equals(obj) ){
        	cd = "04";
        	title = "이벤트(쁘띠)";
        } else {
        	cd = "01";
        	title = "시술예약(다이어트)";
        }
        
        map.put("cd", cd);
        map.put("title", title);
    	return map;
    	
    }
    
    
}


